/**
 * Der Geist ist eine Gegnerfigur im Pacmanspiel.
 * 
 * @author Klasse 10c
 * @version 2014-12-05
 */
public class Geist
{
    // Attribute
    private int positionX;
    private int positionY;
    private boolean verwundbar;
    private String gesundeFarbe;
    private String krankeFarbe;

    // Referenzattribute zum Zeichnen
    private Kreissektor kopf;
    private Rechteck rumpf;
    private Kreissektor auge1;
    private Kreissektor auge2;
    private Kreissektor pupille1;
    private Kreissektor pupille2;

    /**
     * Konstruktor.
     * Erzeuge einen Geist in der gewnschten gesunden und kranken
     * Farbe und positioniere ihn an das Levelfeld (x|y).
     */
    public Geist (String gFarbe, String kFarbe, int x, int y)
    {
        positionX  = 1;
        positionY  = 1;
        verwundbar = false;

        gesundeFarbe = gFarbe;
        krankeFarbe  = kFarbe;

        kopf = new Kreissektor ();
        kopf.setzeAnfangswinkel (0);
        kopf.setzeGesamtwinkel (180);
        kopf.setzeFarbe (gesundeFarbe);
        kopf.setzeRadius (40);
        kopf.setzePosition (10, 10);

        rumpf = new Rechteck ();
        rumpf.setzeFarbe (gesundeFarbe);
        rumpf.setzeBreite (80);
        rumpf.setzeHoehe (50);
        rumpf.setzePosition (10, 50);

        auge1 = new Kreissektor ();
        auge1.setzeAnfangswinkel (0);
        auge1.setzeGesamtwinkel (360);
        auge1.setzeFarbe ("weiss");
        auge1.setzeRadius (10);
        auge1.setzePosition (25, 30);

        auge2 = new Kreissektor ();
        auge2.setzeAnfangswinkel (0);
        auge2.setzeGesamtwinkel (360);
        auge2.setzeFarbe ("weiss");
        auge2.setzeRadius (10);
        auge2.setzePosition (55, 30);

        pupille1 = new Kreissektor ();
        pupille1.setzeAnfangswinkel (55);
        pupille1.setzeGesamtwinkel (330);
        pupille1.setzeFarbe ("schwarz");
        pupille1.setzeRadius (7);
        pupille1.setzePosition (28, 33);

        pupille2 = new Kreissektor ();
        pupille2.setzeAnfangswinkel (55);
        pupille2.setzeGesamtwinkel (330);
        pupille2.setzeFarbe ("schwarz");
        pupille2.setzeRadius (7);
        pupille2.setzePosition (58, 33);
        
        bewegeNach (x, y);
    }
    
    /**
     * Bewege den Geist zum Levelfeld (x|y)
     */
    public void bewegeNach (int x, int y)
    {
        rumpf.setzePosition (x * 100 - 99 + 10, y * 100 - 99 + 50);
        kopf.setzePosition (x * 100 - 99 + 10, y * 100 - 99 + 10);
        auge1.setzePosition (x * 100 - 99 + 25, y * 100 - 99 + 30);
        auge2.setzePosition (x * 100 - 99 + 55, y * 100 - 99 + 30);
        pupille1.setzePosition (x * 100 - 99 + 28, y * 100 - 99 + 33);
        pupille2.setzePosition (x * 100 - 99 + 58, y * 100 - 99 + 33);
        
        positionX = x;
        positionY = y;
    }

    /**
     * Mache den Geist verwundbar.
     */
    public void werdeVerwundbar ()
    {
        verwundbar = true;

        rumpf.setzeFarbe (krankeFarbe);
        kopf.setzeFarbe (krankeFarbe);
        auge1.werdeSichtbar ();
        auge2.werdeSichtbar ();
        pupille1.werdeSichtbar ();
        pupille2.werdeSichtbar ();
    }

    /**
     * Mache den Geist unverwundbar.
     */
    public void werdeUnverwundbar ()
    {
        verwundbar = false;

        rumpf.setzeFarbe (gesundeFarbe);
        kopf.setzeFarbe (gesundeFarbe);
        auge1.werdeSichtbar ();
        auge2.werdeSichtbar ();
        pupille1.werdeSichtbar ();
        pupille2.werdeSichtbar ();
    }
    
    /**
     * Mache den Geist sichtbar.
     */
    public void werdeSichtbar ()
    { 
        rumpf.werdeSichtbar ();
        kopf.werdeSichtbar ();
        auge1.werdeSichtbar ();
        auge2.werdeSichtbar ();
        pupille1.werdeSichtbar ();
        pupille2.werdeSichtbar ();
    }
    
    /**
     * Mache den Geist sichtbar.
     */
    public void werdeUnsichtbar ()
    { 
        rumpf.werdeUnsichtbar ();
        kopf.werdeUnsichtbar ();
        auge1.werdeUnsichtbar ();
        auge2.werdeUnsichtbar ();
        pupille1.werdeUnsichtbar ();
        pupille2.werdeUnsichtbar ();
    }
    public void jage ()
    {
        if (gesundeFarbe == "rot")
        {
            if (positionX < 9)
            {
                bewegeNach (positionX + 1, positionY);
            }
            else
            {
                bewegeNach (1, positionY);
            }
        }
        if (gesundeFarbe == "pink")
        {
            if (positionY < 7)
            {
                bewegeNach (positionX, positionY + 1);
            }
            else
            {
                bewegeNach (positionX, 1);
            }
        }
        if (gesundeFarbe == "tuerkis")
        {  
            if (positionX > 1)
            {
                bewegeNach (positionX - 1, positionY);
            }
            else
            {
                bewegeNach (9, positionY);
            } 
        }
        if (gesundeFarbe == "orange")
        {     
            if (positionY > 1)
            {
                bewegeNach (positionX, positionY - 1);
            }
            else
            {
                bewegeNach (positionX, 7);
            }
        }
    }
}
